.backend:
  extends: .component
  cache:
    key: "$CI_COMMIT_REF_SLUG-$COMPONENT_NAME"
    paths:
      - .cache/pip
      - venv/
  before_script:
    - pip install virtualenv
    - virtualenv venv
    - source venv/bin/activate
    - !reference [.component, before_script]
    - pip install -r requirements.txt
  variables:
    COMPONENT_NAME: backend
    COMPONENT_PATH: backend
    COMPONENT_IMAGE: python:3.11
    PIP_CACHE_DIR: $CI_PROJECT_DIR/.cache/pip

backend/build:
  extends:
    - .backend
    - .build
  script:
    - pip list

backend/verify:
  extends:
    - .backend
    - .verify
  script:
    - pip install pylint
    - pylint app

backend/unit-test:
  extends: 
    - .backend
    - .test
  script:
    - pip install pytest
    - pytest tests/unit/*

backend/integration-test:
  extends: 
    - .backend
    - .test
  script:
    - pip install pytest
    - pytest tests/integration/*

backend/deploy:
  extends:
    - .build-docker
    - .deploy
  variables:
    !reference [.backend, variables]

backend/documentation:
  extends:
    - .backend
    - .documentation
  script:
    - echo "docs"
